
%global _hardened_build 1

%if ( 0%{?suse_version} )
BuildRequires: distribution-release
%if ( ! 0%{?is_opensuse} )
BuildRequires: sles-release >= 12
Requires: sles-release >= 12
%else
BuildRequires: openSUSE-release
Requires: openSUSE-release
%endif
%endif

# Conditionally enable some FSALs, disable others.
#
# 1. rpmbuild accepts these options (gpfs as example):
#    --with gpfs
#    --without gpfs

%define on_off_switch() %%{?with_%1:ON}%%{!?with_%1:OFF}

# A few explanation about %%bcond_with and %%bcond_without
# /!\ be careful: this syntax can be quite messy
# %%bcond_with means you add a "--with" option, default = without this feature
Patch0001: 0001-Ignore-prctl-failure-for-containerized-setup.patch
Patch0002: 0002-nfs_convert.c-add-missing-NFS4_OP_LAYOUTSTATS.patch
Patch0003: 0003-nfs_init.c-initialize-connection-manager-for-metrics.patch
Patch0004: 0004-clientid-fix-Coverity-CID-502248-mutex-ordering.patch
Patch0005: 0005-Config-Parser-Optimized-the-parsing-of-config-file.patch
Patch0006: 0006-src-SAL-nfs4_owner.c-Don-t-access-owner-if-it-s-NULL.patch
Patch0007: 0007-Avoid-double-release-of-read-buffers.patch
Patch0008: 0008-Prevent-nfs3-read-from-generating-bad-reply.patch
Patch0009: 0009-Avoid-deref-of-uninitialized-pointer.patch
Patch0010: 0010-FSAL_CEPH-Fix-null-pointer-reference.patch

# %%bcond_without adds a "--without" so the feature is enabled by default

%bcond_with nullfs
%global use_fsal_null %{on_off_switch nullfs}

%bcond_with mem
%global use_fsal_mem %{on_off_switch mem}

%bcond_with gpfs
%global use_fsal_gpfs %{on_off_switch gpfs}

%bcond_with xfs
%global use_fsal_xfs %{on_off_switch xfs}

%bcond_with lustre
%global use_fsal_lustre %{on_off_switch lustre}

%bcond_without ceph
%global use_fsal_ceph %{on_off_switch ceph}

%bcond_without rgw
%global use_fsal_rgw %{on_off_switch rgw}

%bcond_with gluster
%global use_fsal_gluster %{on_off_switch gluster}

%bcond_with saunafs
%global use_fsal_saunafs %{on_off_switch saunafs}

%bcond_with kvsfs
%global use_fsal_kvsfs %{on_off_switch kvsfs}

%bcond_with rdma
%global use_rdma %{on_off_switch rdma}

%bcond_with 9P
%global use_9P %{on_off_switch 9P}

%bcond_with jemalloc

%bcond_with tcmalloc

%bcond_with lttng
%global use_lttng %{on_off_switch lttng}

%bcond_without utils
%global use_utils %{on_off_switch utils}

%bcond_with gui_utils
%global use_gui_utils %{on_off_switch gui_utils}

%bcond_without system_ntirpc
%global use_system_ntirpc %{on_off_switch system_ntirpc}

%bcond_with man_page
%global use_man_page %{on_off_switch man_page}

%bcond_without rados_recov
%global use_rados_recov %{on_off_switch rados_recov}

%bcond_without rados_urls
%global use_rados_urls %{on_off_switch rados_urls}

%bcond_without rpcbind
%global use_rpcbind %{on_off_switch rpcbind}

%bcond_with unwind
%global use_unwind %{on_off_switch unwind}

%bcond_without mspac_support
%global use_mspac_support %{on_off_switch mspac_support}

%bcond_with sanitize_address
%global use_sanitize_address %{on_off_switch sanitize_address}

%bcond_without legacy_python_install
%global use_legacy_python_install %{on_off_switch legacy_python_install}

%bcond_without monitoring
%global use_monitoring %{on_off_switch monitoring}

%if ( 0%{?rhel} && 0%{?rhel} < 7 )
%global _rundir %{_localstatedir}/run
%endif

%global dev_version %{lua: s = string.gsub('@GANESHA_EXTRA_VERSION@', '^%-', ''); s2 = string.gsub(s, '%-', '.'); print((s2 ~= nil and s2 ~= '') and s2 or "0.1") }

%define sourcename nfs-ganesha-6.0

Name:		nfs-ganesha
Version:	6.0
Release:	8.1%{?dist}
Summary:	NFS-Ganesha is a NFS Server running in user space
License:	LGPLv3+
Url:		https://github.com/nfs-ganesha/nfs-ganesha/wiki

Source:		%{sourcename}.tar.gz
## prometheus-cpp-lite submodule tarball needed for monitoring in V6.0:
#Source100:	prometheus-cpp-lite.tar.gz
%global prometh_ver_long        48d09c45ee6deb90e02579b03037740e1c01fd27
%global prometh_ver_short       48d09c45
Source100:	https://github.com/biaks/prometheus-cpp-lite/archive/%{prometh_ver_long}/prometheus-cpp-lite-%{prometh_ver_short}.tar.gz

BuildRequires:	cmake
BuildRequires:	make
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	pkgconfig
BuildRequires:	userspace-rcu-devel
BuildRequires:	krb5-devel
BuildRequires:	zlib-devel
BuildRequires:	libcurl-devel
%if %{with rados_recov} || %{with rados_urls}
BuildRequires: librados-devel >= 0.61
%endif
%if ( 0%{?suse_version} >= 1330 )
BuildRequires:  libnsl-devel
%else
%if ( 0%{?fedora} >= 28 || 0%{?rhel} >= 8 )
BuildRequires:  libnsl2-devel
%endif
%endif
%if ( 0%{?suse_version} )
BuildRequires:	dbus-1-devel
Requires:	dbus-1
%else
BuildRequires:	dbus-devel
Requires:	dbus
%endif

%if ( 0%{?suse_version} )
BuildRequires:	systemd-rpm-macros
%endif

BuildRequires:	libcap-devel
BuildRequires:	libblkid-devel
BuildRequires:	libuuid-devel
%if ( 0%{?with_mspac_support} )
BuildRequires:	libwbclient-devel
%endif
BuildRequires:	gcc-c++
%if ( %{with_system_ntirpc} )
BuildRequires: libntirpc-devel >= 6.0
%else
Requires: libntirpc = 6.0
%endif
%if %{with sanitize_address}
BuildRequires:	libasan
%endif
Requires:	nfs-utils

%if %{with monitoring}
Requires:	gmonitoring
%endif

%if ( 0%{?with_rpcbind} )
%if ( 0%{?fedora} ) || ( 0%{?rhel} && 0%{?rhel} >= 6 ) || ( 0%{?suse_version} )
Requires:	rpcbind
%else
Requires:	portmap
%endif
%endif

%if ( 0%{?suse_version} )
BuildRequires:	nfsidmap-devel
%else
BuildRequires:	libnfsidmap-devel
%endif

%if %{with rdma}
BuildRequires:	libmooshika-devel >= 0.6-0
%endif
%if %{with jemalloc}
BuildRequires:	jemalloc-devel
%endif
%if %{with tcmalloc}
BuildRequires:  gperftools-devel
%endif
BuildRequires: systemd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
%if %{with man_page}
%if ( 0%{?rhel} && 0%{?rhel} < 8 )
BuildRequires: python-sphinx
%else
%if ( 0%{?suse_version} )
BuildRequires: python3-Sphinx
%else
BuildRequires: python3-sphinx
%endif
%endif
%endif
Requires(post): psmisc
Requires(pre): /usr/sbin/useradd
Requires(pre): /usr/sbin/groupadd

%if ( 0%{?fedora} >= 30 || 0%{?rhel} >= 8 )
Requires: nfs-ganesha-selinux = %{version}-%{release}
%endif

# Use CMake variables

%description
nfs-ganesha : NFS-GANESHA is a NFS Server running in user space.
It comes with various back-end modules (called FSALs) provided as
shared objects to support different file systems and name-spaces.

%if %{with 9P}
%package mount-9P
Summary: a 9p mount helper

%description mount-9P
This package contains the mount.9P script that clients can use
to simplify mounting to NFS-GANESHA. This is a 9p mount helper.
%endif

%if %{with monitoring}
%package -n gmonitoring
Summary: The NFS-GANESHA Monitoring module
Group: Applications/System
Provides: libgmonitoring.so

%description -n gmonitoring
The monitoring module contains metrics collectors and HTTP exposer
in Prometheus format.
%endif

%package vfs
Summary: The NFS-GANESHA VFS FSAL
BuildRequires: libattr-devel
Obsoletes: %{name}-xfs <= %{version}
Requires: nfs-ganesha = %{version}-%{release}

%description vfs
This package contains a FSAL shared object to
be used with NFS-Ganesha to support VFS based filesystems

%package proxy-v4
Summary: The NFS-GANESHA PROXY_V4 FSAL
BuildRequires: libattr-devel
Requires: nfs-ganesha = %{version}-%{release}

%description proxy-v4
This package contains a FSAL shared object to
be used with NFS-Ganesha to support PROXY_V4 based filesystems

%package proxy-v3
Summary: The NFS-GANESHA PROXY_V3 FSAL
BuildRequires: libattr-devel
Requires: nfs-ganesha = %{version}-%{release}

%description proxy-v3
This package contains a FSAL shared object to
be used with NFS-Ganesha to support PROXY_V3 based filesystems

%if %{with utils}
%package utils
Summary: The NFS-GANESHA util scripts
%if ( 0%{?rhel} && 0%{?rhel} < 8 )
Requires:       dbus-python, pygobject2, pyparsing
BuildRequires:  python-devel
%else
Requires:	python3-gobject, python3-pyparsing
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
%if ( 0%{?suse_version} )
Requires:	dbus-1-python
%else
Requires:	python3-dbus
%endif
%if ( ! 0%{?with_legacy_python_install} )
BuildRequires:	python3-wheel
BuildRequires:	python3-build
BuildRequires:	python3-installer
%endif
%endif

%if %{with unwind}
Requires:	glibc-devel
%endif

%if %{with gui_utils}
%if ( 0%{?suse_version} )
BuildRequires:	python-qt5-devel
%else
%if ( 0%{?fedora} >= 31 || 0%{?rhel} >= 8 )
BuildRequires:	python3-qt5-devel
%else
BuildRequires:	PyQt4-devel
%endif
%endif
%endif

%description utils
This package contains utility scripts for managing the NFS-GANESHA server
%endif

%if %{with lttng}
%package lttng
Summary: The NFS-GANESHA library for use with LTTng
BuildRequires: lttng-ust-devel >= 2.3
BuildRequires: lttng-tools-devel >= 2.3
Requires: nfs-ganesha = %{version}-%{release}, lttng-tools >= 2.3,  lttng-ust >= 2.3

%description lttng
This package contains the libganesha_trace.so library. When preloaded
to the ganesha.nfsd server, it makes it possible to trace using LTTng.
%endif

%if %{with rados_recov}
%package rados-grace
Summary: The NFS-GANESHA command for managing the RADOS grace database
Requires: nfs-ganesha = %{version}-%{release}

%description rados-grace
This package contains the ganesha-rados-grace tool for interacting with the
database used by the rados_cluster recovery backend and the
libganesha_rados_grace shared library for using RADOS storage for
recovery state.
%endif

%if %{with rados_urls}
%package rados-urls
Summary: The NFS-GANESHA library for use with RADOS URLs
Group: Applications/System
Requires: nfs-ganesha = %{version}-%{release}

%description rados-urls
This package contains the libganesha_rados_urls library used for
handling RADOS URL configurations.
%endif

# Option packages start here. use "rpmbuild --with gpfs" (or equivalent)
# for activating this part of the spec file

# NULL
%if %{with nullfs}
%package nullfs
Summary: The NFS-GANESHA NULLFS Stackable FSAL
Requires: nfs-ganesha = %{version}-%{release}

%description nullfs
This package contains a Stackable FSAL shared object to
be used with NFS-Ganesha. This is mostly a template for future (more sophisticated) stackable FSALs
%endif

# MEM
%if %{with mem}
%package mem
Summary: The NFS-GANESHA Memory backed testing FSAL
Requires: nfs-ganesha = %{version}-%{release}

%description mem
This package contains a FSAL shared object to be used with NFS-Ganesha.  This
is used for speed and latency testing.
%endif

# GPFS
%if %{with gpfs}
%package gpfs
Summary: The NFS-GANESHA GPFS FSAL
Requires: nfs-ganesha = %{version}-%{release}

%description gpfs
This package contains a FSAL shared object to
be used with NFS-Ganesha to support GPFS backend
%endif

# CEPH
%if %{with ceph}
%package ceph
Summary: The NFS-GANESHA CephFS FSAL
Requires:	nfs-ganesha = %{version}-%{release}
BuildRequires:	libcephfs2-devel >= 12.2.0
BuildRequires:	libacl-devel

%description ceph
This package contains a FSAL shared object to
be used with NFS-Ganesha to support CephFS
%endif

# RGW
%if %{with rgw}
%package rgw
Summary: The NFS-GANESHA Ceph RGW FSAL
Requires:	nfs-ganesha = %{version}-%{release}
BuildRequires:	librgw2-devel >= 12.2.0

%description rgw
This package contains a FSAL shared object to
be used with NFS-Ganesha to support Ceph RGW
%endif

# XFS
%if %{with xfs}
%package xfs
Summary: The NFS-GANESHA XFS FSAL
Requires:	nfs-ganesha = %{version}-%{release}
BuildRequires:	libattr-devel xfsprogs-devel

%description xfs
This package contains a shared object to be used with FSAL_VFS
to support XFS correctly
%endif

#LUSTRE
%if %{with lustre}
%package lustre
Summary: The NFS-GANESHA LUSTRE FSAL
BuildRequires: libattr-devel
BuildRequires: lustre-client
Requires: nfs-ganesha = %{version}-%{release}
Requires: lustre-client

%description lustre
This package contains a FSAL shared object to
be used with NFS-Ganesha to support LUSTRE based filesystems
%endif

# KVSFS
%if %{with kvsfs}
%package kvsfs
Summary: The NFS-GANESHA KVSFS FSAL
Requires:       nfs-ganesha = %{version}-%{release}
Requires:       libkvsns >= 1.2.0
BuildRequires:  libkvsns-devel >= 1.2.0

%description kvsfs
This package contains a FSAL shared object to
be used with NFS-Ganesha to support KVSFS/libkvsns
%endif

# GLUSTER
%if %{with gluster}
%package gluster
Summary: The NFS-GANESHA GLUSTER FSAL
Requires:	nfs-ganesha = %{version}-%{release}
BuildRequires:        glusterfs-api-devel >= 6.0
BuildRequires:        libattr-devel, libacl-devel

%description gluster
This package contains a FSAL shared object to
be used with NFS-Ganesha to support Gluster
%endif

# SAUNA 
%if ( 0%{?with_saunafs} )
%package saunafs
Summary: The NFS-GANESHA SAUNAFS FSAL
Requires:      nfs-ganesha = %{version}-%{release}

%description saunafs
This package contains a FSAL shared object to
be used with NFS-Ganesha to support Sauna FS
%endif

# SELINUX
%if ( 0%{?fedora} >= 30 || 0%{?rhel} >= 8 )
%package selinux
Summary: The NFS-GANESHA SELINUX targeted policy
BuildArch:	noarch
Requires:	nfs-ganesha = %{version}-%{release}
BuildRequires: selinux-policy-devel
%{?selinux_requires}

%description selinux
This package contains an selinux policy for running ganesha.nfsd

%post selinux
%selinux_modules_install %{_selinux_store_path}/packages/ganesha.pp.bz2

%pre selinux
%selinux_relabel_pre

%postun selinux
if [ $1 -eq 0 ]; then
    %selinux_modules_uninstall ganesha
fi

%posttrans
%selinux_relabel_post
%endif


# NTIRPC (if built-in)
%if ! %{with system_ntirpc}
%package -n libntirpc
Summary:	New Transport Independent RPC Library
License:	BSD
Version:	6.0
Url:		https://github.com/nfs-ganesha/ntirpc

# libtirpc has /etc/netconfig, most machines probably have it anyway
# for NFS client
Requires:	libtirpc

%if %{with monitoring}
Requires:	gmonitoring
%endif

%description -n libntirpc
This package contains a new implementation of the original libtirpc,
transport-independent RPC (TI-RPC) library for NFS-Ganesha. It has
the following features not found in libtirpc:
 1. Bi-directional operation
 2. Full-duplex operation on the TCP (vc) transport
 3. Thread-safe operating modes
 3.1 new locking primitives and lock callouts (interface change)
 3.2 stateless send/recv on the TCP transport (interface change)
 4. Flexible server integration support
 5. Event channels (remove static arrays of xprt handles, new EPOLL/KEVENT
    integration)

%package -n libntirpc-devel
Summary:	Development headers for libntirpc
Requires:	libntirpc = 6.0
License:	BSD
Version:	6.0
Url:		https://github.com/nfs-ganesha/ntirpc

%description -n libntirpc-devel
Development headers and auxiliary files for developing with %{name}.
%endif

%prep
%setup -q -n %{sourcename}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1

# prometheus-cpp-lite submodule:
tar xzf %{SOURCE100}

%build
# Handle the prometheus-cpp-lite submodule first:
mv ./prometheus-cpp-lite-%{prometh_ver_long}/* ./src/monitoring/prometheus-cpp-lite

cd src && %{cmake} . -DCMAKE_BUILD_TYPE=RelWithDebInfo	\
	-DBUILD_CONFIG=rpmbuild				\
	-DUSE_FSAL_NULL=%{use_fsal_null}		\
	-DUSE_FSAL_MEM=%{use_fsal_mem}			\
	-DUSE_FSAL_XFS=%{use_fsal_xfs}			\
	-DUSE_FSAL_LUSTRE=%{use_fsal_lustre}		\
	-DUSE_FSAL_CEPH=%{use_fsal_ceph}		\
	-DUSE_FSAL_RGW=%{use_fsal_rgw}			\
	-DUSE_FSAL_GPFS=%{use_fsal_gpfs}		\
	-DUSE_FSAL_KVSFS=%{use_fsal_kvsfs}		\
	-DUSE_FSAL_GLUSTER=%{use_fsal_gluster}		\
	-DUSE_FSAL_SAUNAFS=%{use_fsal_saunafs}          \
	-DUSE_SYSTEM_NTIRPC=%{use_system_ntirpc}	\
	-DUSE_9P_RDMA=%{use_rdma}			\
	-DUSE_LTTNG=%{use_lttng}			\
	-DUSE_UNWIND=%{use_unwind}			\
	-DUSE_ADMIN_TOOLS=%{use_utils}			\
	-DUSE_GUI_ADMIN_TOOLS=%{use_gui_utils}		\
	-DUSE_RADOS_RECOV=%{use_rados_recov}		\
	-DRADOS_URLS=%{use_rados_urls}			\
	-DUSE_FSAL_VFS=ON				\
 	-DUSE_FSAL_PROXY_V4=ON				\
 	-DUSE_FSAL_PROXY_V3=ON				\
	-DUSE_DBUS=ON					\
	-DUSE_MONITORING=%{use_monitoring}		\
	-DUSE_9P=%{use_9P}				\
	-DDISTNAME_HAS_GIT_DATA=OFF			\
	-DUSE_MAN_PAGE=%{use_man_page}			\
	-DRPCBIND=%{use_rpcbind}			\
	-D_MSPAC_SUPPORT=%{use_mspac_support}		\
	-DSANITIZE_ADDRESS=%{use_sanitize_address}	\
	-DUSE_LEGACY_PYTHON_INSTALL=%{use_legacy_python_install}	\
	-DCMAKE_COLOR_MAKEFILE:BOOL=OFF			\
%if %{with jemalloc}
	-DALLOCATOR=jemalloc
%endif
%if %{with tcmalloc}
	-DALLOCATOR=tcmalloc
%endif

export VERBOSE=1
export GCC_COLORS=
%cmake_build

%if ( 0%{?fedora} >= 30 || 0%{?rhel} >= 8 )
make -C selinux -f /usr/share/selinux/devel/Makefile ganesha.pp
pushd selinux && bzip2 -9 ganesha.pp && popd
%endif

%install
mkdir -p %{buildroot}%{_sysconfdir}/ganesha/
mkdir -p %{buildroot}%{_sysconfdir}/dbus-1/system.d
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_libdir}/ganesha
mkdir -p %{buildroot}%{_rundir}/ganesha
mkdir -p %{buildroot}%{_libexecdir}/ganesha
cd src
install -m 644 config_samples/logrotate_ganesha	%{buildroot}%{_sysconfdir}/logrotate.d/ganesha
install -m 644 scripts/ganeshactl/org.ganesha.nfsd.conf	%{buildroot}%{_sysconfdir}/dbus-1/system.d
install -m 755 scripts/nfs-ganesha-config.sh %{buildroot}%{_libexecdir}/ganesha
%if %{with 9P}
install -m 755 tools/mount.9P	%{buildroot}%{_sbindir}/mount.9P
%endif

install -m 644 config_samples/vfs.conf %{buildroot}%{_sysconfdir}/ganesha
%if %{with rgw}
install -m 644 config_samples/rgw.conf %{buildroot}%{_sysconfdir}/ganesha
%endif

mkdir -p %{buildroot}%{_unitdir}
%if ( 0%{?fedora} ) || ( 0%{?rhel} && 0%{?rhel} >= 8 )
mkdir -p %{buildroot}%{_sysconfdir}/systemd/system/nfs-ganesha-lock.service.d
%endif

install -m 644 scripts/systemd/nfs-ganesha.service.el7	%{buildroot}%{_unitdir}/nfs-ganesha.service
%if ( 0%{?fedora} ) || ( 0%{?rhel} && 0%{?rhel} >= 8 )
install -m 644 scripts/systemd/nfs-ganesha-lock.service.el8	%{buildroot}%{_unitdir}/nfs-ganesha-lock.service
install -m 644 scripts/systemd/rpc-statd.conf.el8	%{buildroot}%{_sysconfdir}/systemd/system/nfs-ganesha-lock.service.d/rpc-statd.conf
%else
install -m 644 scripts/systemd/nfs-ganesha-lock.service.el7	%{buildroot}%{_unitdir}/nfs-ganesha-lock.service
%endif
install -m 644 scripts/systemd/nfs-ganesha-config.service %{buildroot}%{_unitdir}/nfs-ganesha-config.service
install -m 644 scripts/systemd/sysconfig/nfs-ganesha	%{buildroot}%{_sysconfdir}/sysconfig/ganesha
mkdir -p %{buildroot}%{_localstatedir}/log/ganesha

%if %{with lustre}
install -m 644 config_samples/lustre.conf %{buildroot}%{_sysconfdir}/ganesha
%endif

%if %{with xfs}
install -m 644 config_samples/xfs.conf %{buildroot}%{_sysconfdir}/ganesha
%endif

%if %{with ceph}
install -m 644 config_samples/ceph.conf %{buildroot}%{_sysconfdir}/ganesha
%endif

%if %{with rgw}
install -m 644 config_samples/rgw.conf %{buildroot}%{_sysconfdir}/ganesha
install -m 644 config_samples/rgw_bucket.conf %{buildroot}%{_sysconfdir}/ganesha
%endif

%if %{with gluster}
install -m 644 config_samples/logrotate_fsal_gluster %{buildroot}%{_sysconfdir}/logrotate.d/ganesha-gfapi
%endif

%if %{with gpfs}
install -m 644 config_samples/gpfs.conf	%{buildroot}%{_sysconfdir}/ganesha
install -m 644 config_samples/gpfs.ganesha.nfsd.conf %{buildroot}%{_sysconfdir}/ganesha
install -m 644 config_samples/gpfs.ganesha.main.conf %{buildroot}%{_sysconfdir}/ganesha
install -m 644 config_samples/gpfs.ganesha.log.conf %{buildroot}%{_sysconfdir}/ganesha
install -m 644 config_samples/gpfs.ganesha.exports.conf	%{buildroot}%{_sysconfdir}/ganesha
%endif

%cmake_install

%if ( 0%{?fedora} >= 30 || 0%{?rhel} >= 8 )
install -d %{buildroot}%{_selinux_store_path}/packages
install -d -p %{buildroot}%{_selinux_store_path}/devel/include/contrib
install -p -m 644 selinux/ganesha.if %{buildroot}%{_selinux_store_path}/devel/include/contrib
install -m 0644 selinux/ganesha.pp.bz2 %{buildroot}%{_selinux_store_path}/packages
%endif

%if ( ! 0%{?with_legacy_python_install} )
%if ( 0%{?with_gpfs} )
mv %{buildroot}/usr/bin/gpfs-epoch %{buildroot}/usr/libexec/ganesha/
%endif
%endif

%if ( 0%{?rhel} && 0%{?rhel} < 8 )
rm -rf %{buildroot}/%{python_sitelib}/gpfs*
rm -f %{buildroot}/%{python_sitelib}/__init__.*
%else
rm -rf %{buildroot}/%{python3_sitelib}/gpfs*
rm -rf %{buildroot}/%{python3_sitelib}/ganeshactl*
rm -f %{buildroot}/%{python3_sitelib}/__init__.*
rm -rf %{buildroot}/%{python3_sitelib}/__pycache__
rm -f %{buildroot}/%{python3_sitelib}/Ganesha/__init__.*
rm -f %{buildroot}/%{python3_sitelib}/Ganesha/QtUI/__init__.*
rm -rf %{buildroot}/%{python3_sitelib}/Ganesha/QtUI/__pycache__
%endif

%post
%if ( 0%{?suse_version} )
%service_add_post nfs-ganesha.service nfs-ganesha-lock.service nfs-ganesha-config.service
%else
%if ( 0%{?fedora} || ( 0%{?rhel} && 0%{?rhel} > 6 ) )
semanage fcontext -a -t ganesha_var_log_t %{_localstatedir}/log/ganesha > /dev/null 2>&1 || :
semanage fcontext -a -t ganesha_var_log_t %{_localstatedir}/log/ganesha/ganesha.log > /dev/null 2>&1 || :
%if %{with gluster}
semanage fcontext -a -t ganesha_var_log_t %{_localstatedir}/log/ganesha/ganesha-gfapi.log > /dev/null 2>&1 || :
%endif
restorecon %{_localstatedir}/log/ganesha
%endif
%systemd_post nfs-ganesha.service
%systemd_post nfs-ganesha-lock.service
%systemd_post nfs-ganesha-config.service
%endif
killall -SIGHUP dbus-daemon >/dev/null 2>&1 || :

%pre
getent group ganesha > /dev/null || groupadd -r ganesha
getent passwd ganesha > /dev/null || useradd -r -g ganesha -d %{_rundir}/ganesha -s /sbin/nologin -c "NFS-Ganesha Daemon" ganesha
exit 0

%preun
%if ( 0%{?suse_version} )
%service_del_preun nfs-ganesha-lock.service
%else
%systemd_preun nfs-ganesha-lock.service
%endif

%postun
%if ( 0%{?suse_version} )
%service_del_postun nfs-ganesha-lock.service
%debug_package
%else
%systemd_postun_with_restart nfs-ganesha-lock.service
%endif

%files
%license src/LICENSE.txt
%{_bindir}/ganesha.nfsd
%{_libdir}/libganesha_nfsd.so*
%config %{_sysconfdir}/dbus-1/system.d/org.ganesha.nfsd.conf
%config(noreplace) %{_sysconfdir}/sysconfig/ganesha
%config(noreplace) %{_sysconfdir}/logrotate.d/ganesha
%dir %{_sysconfdir}/ganesha/
%config(noreplace) %{_sysconfdir}/ganesha/ganesha.conf
%dir %{_rundir}/ganesha
%dir %{_libexecdir}/ganesha/
%{_libexecdir}/ganesha/nfs-ganesha-config.sh
%dir %attr(0755,ganesha,ganesha) %{_localstatedir}/log/ganesha

%{_unitdir}/nfs-ganesha.service
%{_unitdir}/nfs-ganesha-lock.service
%{_unitdir}/nfs-ganesha-config.service
%if ( 0%{?fedora} ) || ( 0%{?rhel} && 0%{?rhel} >= 8 )
%{_sysconfdir}/systemd/system/nfs-ganesha-lock.service.d/rpc-statd.conf
%endif

%if %{with man_page}
%{_mandir}/*/ganesha-config.8.gz
%{_mandir}/*/ganesha-core-config.8.gz
%{_mandir}/*/ganesha-export-config.8.gz
%{_mandir}/*/ganesha-cache-config.8.gz
%{_mandir}/*/ganesha-log-config.8.gz
%endif


%if %{with rados_recov}
%files rados-grace
%{_bindir}/ganesha-rados-grace
%{_libdir}/libganesha_rados_recov.so*
%if %{with man_page}
%{_mandir}/*/ganesha-rados-grace.8.gz
%{_mandir}/*/ganesha-rados-cluster-design.8.gz
%endif
%endif

%if %{with rados_urls}
%files rados-urls
%{_libdir}/libganesha_rados_urls.so*
%endif

%if %{with 9P}
%files mount-9P
%{_sbindir}/mount.9P
%if %{with man_page}
%{_mandir}/*/ganesha-9p-config.8.gz
%endif
%endif

%if %{with monitoring}
%files -n gmonitoring
%{_libdir}/libgmonitoring*
%endif

%files vfs
%{_libdir}/ganesha/libfsalvfs*
%config(noreplace) %{_sysconfdir}/ganesha/vfs.conf
%if %{with man_page}
%{_mandir}/*/ganesha-vfs-config.8.gz
%endif

%files proxy-v4
%{_libdir}/ganesha/libfsalproxy_v4*
%if %{with man_page}
%{_mandir}/*/ganesha-proxy-v4-config.8.gz
%endif
 
%files proxy-v3
%{_libdir}/ganesha/libfsalproxy_v3*
%if %{with man_page}
%{_mandir}/*/ganesha-proxy-v3-config.8.gz
%endif

# Optional packages
%if %{with lustre}
%files lustre
%{_libdir}/ganesha/libfsallustre*
%config(noreplace) %{_sysconfdir}/ganesha/lustre.conf
%if %{with man_page}
%{_mandir}/*/ganesha-lustre-config.8.gz
%endif
%endif

%if %{with nullfs}
%files nullfs
%{_libdir}/ganesha/libfsalnull*
%endif

%if %{with mem}
%files mem
%{_libdir}/ganesha/libfsalmem*
%endif

%if %{with gpfs}
%files gpfs
%{_libdir}/ganesha/libfsalgpfs*
%config(noreplace) %{_sysconfdir}/ganesha/gpfs.conf
%config(noreplace) %{_sysconfdir}/ganesha/gpfs.ganesha.nfsd.conf
%config(noreplace) %{_sysconfdir}/ganesha/gpfs.ganesha.main.conf
%config(noreplace) %{_sysconfdir}/ganesha/gpfs.ganesha.log.conf
%config(noreplace) %{_sysconfdir}/ganesha/gpfs.ganesha.exports.conf
%if %{with utils}
%{_libexecdir}/ganesha/gpfs-epoch
%endif
%if %{with man_page}
%{_mandir}/*/ganesha-gpfs-config.8.gz
%endif
%endif

%if %{with xfs}
%files xfs
%{_libdir}/ganesha/libfsalxfs*
%config(noreplace) %{_sysconfdir}/ganesha/xfs.conf
%if %{with man_page}
%{_mandir}/*/ganesha-xfs-config.8.gz
%endif
%endif

%if %{with ceph}
%files ceph
%{_libdir}/ganesha/libfsalceph*
%config(noreplace) %{_sysconfdir}/ganesha/ceph.conf
%if %{with man_page}
%{_mandir}/*/ganesha-ceph-config.8.gz
%endif
%endif

%if %{with rgw}
%files rgw
%{_libdir}/ganesha/libfsalrgw*
%config(noreplace) %{_sysconfdir}/ganesha/rgw.conf
%config(noreplace) %{_sysconfdir}/ganesha/rgw_bucket.conf
%if %{with man_page}
%{_mandir}/*/ganesha-rgw-config.8.gz
%endif
%endif

%if %{with gluster}
%files gluster
%config(noreplace) %{_sysconfdir}/logrotate.d/ganesha-gfapi
%{_libdir}/ganesha/libfsalgluster*
%if %{with man_page}
%{_mandir}/*/ganesha-gluster-config.8.gz
%endif
%endif

%if ( 0%{?with_saunafs} )
%files saunafs
%{_libdir}/ganesha/libfsalsaunafs*
%endif

%if ( 0%{?fedora} >= 30 || 0%{?rhel} >= 8 )
%files selinux
%attr(0644,root,root) %{_selinux_store_path}/packages/ganesha.pp.bz2
%attr(0644,root,root) %{_selinux_store_path}/devel/include/contrib/ganesha.if
%endif

%if ! %{with system_ntirpc}
%files -n libntirpc
%{_libdir}/libntirpc.so.4.0
%{_libdir}/libntirpc.so
%{!?_licensedir:%global license %%doc}
%license libntirpc/COPYING
%doc libntirpc/NEWS libntirpc/README
%files -n libntirpc-devel
%{_libdir}/pkgconfig/libntirpc.pc
%dir %{_includedir}/ntirpc
%{_includedir}/ntirpc/*
%endif

%if %{with kvsfs}
%files kvsfs
%{_libdir}/ganesha/libfsalkvsfs*
%endif

%if %{with lttng}
%files lttng
%{_libdir}/ganesha/libganesha_trace*
%endif

%if %{with utils}
%files utils
%if ( 0%{?rhel} && 0%{?rhel} < 8 )
%{python_sitelib}/Ganesha/*
%{python_sitelib}/ganeshactl-*-info
%else
%{python3_sitelib}/Ganesha/*
%{python3_sitelib}/*.egg-info
%if ( ! 0%{?with_legacy_python_install} )
%{python3_sitelib}/ganeshactl-*-info
%{python3_sitelib}/ganesha_top-*-info
%endif
%endif
%if %{with gui_utils}
%{_bindir}/ganesha-admin
%{_bindir}/manage_clients
%{_bindir}/manage_exports
%{_bindir}/manage_logger
%{_bindir}/ganeshactl
%if %{with 9P}
%{_bindir}/client_stats_9pOps
%{_bindir}/export_stats_9pOps
%else
%exclude %{_bindir}/client_stats_9pOps
%exclude %{_bindir}/export_stats_9pOps
%endif
%endif
%{_bindir}/fake_recall
%{_bindir}/get_clientids
%{_bindir}/grace_period
%{_bindir}/ganesha_stats
%{_bindir}/sm_notify.ganesha
%{_bindir}/ganesha_mgr
%{_bindir}/ganesha_conf
%{_bindir}/ganesha-top
%{_mandir}/*/ganesha_conf.8.gz
%endif

%changelog
* Thu Jan 23 2025 Thomas Serlin <tserlin@redhat.com> - 6.0-8.1
- Enable ADMIN_TOOLs for nfs-ganesha in Ceph 8.0 z2

* Wed Oct 23 2024 Thomas Serlin <tserlin@redhat.com> - 6.0-8
- Rebuild nfs-ganesha to include updated libntirpc (rhbz#2320396)

* Fri Oct 18 2024 Ceph Jenkins <ceph-jenkins@redhat.com> 6.0-7
- FSAL_CEPH: Fix null pointer reference
- Avoid deref of uninitialized pointer
- Prevent nfs3 read from generating bad reply
- Avoid double release of read buffers
- src/SAL/nfs4_owner.c: Don't access owner if it's NULL.

* Tue Sep 24 2024 Ceph Jenkins <ceph-jenkins@redhat.com> 6.0-6
- Config Parser: Optimized the parsing of config file

* Wed Sep 18 2024 Thomas Serlin <tserlin@redhat.com> - 6.0-5
- Rebuild to include ppc64le arch

* Tue Sep 10 2024 Ceph Jenkins <ceph-jenkins@redhat.com> 6.0-4
- clientid: fix Coverity CID 502248 - mutex ordering
- nfs_init.c: initialize connection manager for metrics
- nfs_convert.c: add missing NFS4_OP_LAYOUTSTATS

* Tue Sep 03 2024 Ceph Jenkins <ceph-jenkins@redhat.com> 6.0-3
- Ignore prctl failure for containerized setup

* Wed Aug 28 2024 Thomas Serlin <tserlin@redhat.com> - 6.0-2
- Better, more reproducible handling of prometheus-cpp-lite
- nfs-ganesha.spec: minor clean-up and alignment with upstream spec file
- Add handling for prometheus-cpp-lite submodule

* Mon Aug 26 2024 Thomas Serlin <tserlin@redhat.com> - 6.0-1
- Update to V6.0

* Wed May 22 2024 Thomas Serlin <tserlin@redhat.com> - 5.9-1
- Update to V5.9

* Wed Apr 24 2024 Ceph Jenkins <ceph-jenkins@redhat.com> 5.7-4
- FSAL_CEPH: Avoid duplicate refcounting of cmount
- FSAL: Fix up gsh_refstr references for op_context.
- nfs4_Check_Stateid must not return NFS4ERR_STALE_STATEID for 4.1
- export_mgr: Dont' leak refstr in get_gsh_export_by_pseudo_locked
- CEPH: Free EXPORT { FSAL {} } config strings

* Mon Apr 01 2024 Ceph Jenkins <ceph-jenkins@redhat.com> 5.7-3
- fsal_fd fd_work/io_work needs separate condition variables
- Add PTHREAD_COND_broadcast macro

* Thu Mar 21 2024 Ceph Jenkins <ceph-jenkins@redhat.com> 5.7-2
- V5.7-2
- Prometheus - make metric names consistent and add a basic info metric
- Insert global FDs of reopened files into fd lru
- Provide FSALs option to remove global FDs from fd_lru upon failures
- Expose bump_fd_lru to FSALs to bump up if reusing global FDs
- Insert to fd_lru only if open/reopen succeeds
- FSAL_CEPH : Add warnings for export creation
- Use after free in fd_lru
- Fix log_an_export critical path overhead
- Fix memory leak in DRC
- GPFS: Fix unexport of 1st export on filesystem
- FSAL: add function to get an export ref from a filesystem.
- Don't leak memory when PSEUDOFS block is not specified.
- Don't leak memory for FSAL_LIST config block
- CONFIG: Add ability to specify a block where memory is not allocated if unused
- Handle delegation recalls for expired clients
- Decrement fd_work while reclaiming if FD is busy
- ACL: fix memory leak
- Fix crash at release_lock_owner()-> _get_gsh_export_ref()
- FSAL_PSEUDO set change, mtime, ctime on create directory
- monitoring: fails to build with gcc-14
- FSAL_CEPH : Add debug statements
- Fix compiler warnings for "-Werror" flag
- LOG : Parse correct name for COMPONENT_MDCACHE_LRU
- Fix monitoring build option
- Ignore clangd cache directory
- FSAL: Fix up how reaper_work is used
- FSAL: in open2 methods, update_share_counters_locked must use *new_obj
- LOG: Fix buffer overflow issue
- Fix crash at free_client_id()->PTHREAD_MUTEX_destroy()
- Fix: dec ref_count of confirmed client_id
- FSAL's state_free function called by free_state doesn't actually free

* Sun Feb 18 2024 Thomas Serlin <tserlin@redhat.com> - 5.7-1
- Update to V5.7

* Mon Nov 13 2023 Ceph Jenkins <ceph-jenkins@redhat.com> 5.6-4
- FSAL's state_free function called by free_state doesn't actually free

* Mon Oct 30 2023 Ceph Jenkins <ceph-jenkins@redhat.com> 5.6-3
- CEPH: Fix up cmount_path

* Wed Oct 25 2023 Ceph Jenkins <ceph-jenkins@redhat.com> 5.6-2
- CEPH: Currently client_oc true is broken, force it to false

* Mon Oct 23 2023 Thomas Serlin <tserlin@redhat.com> - 5.6-1
- Update to V5.6

* Fri Aug 11 2023 Thomas Serlin <tserlin@redhat.com> - 5.5-1
- Update to V5.5

* Mon Jul 24 2023 Thomas Serlin <tserlin@redhat.com> - 5.4-1
- Update to V5.4

* Mon Jul 24 2023 Thomas Serlin <tserlin@redhat.com> - 5.3.3-1
- Update to V5.3.3

* Mon Jul 24 2023 Thomas Serlin <tserlin@redhat.com> - 5.3.2-1
- Update to V5.3.2

* Mon Jul 24 2023 Thomas Serlin <tserlin@redhat.com> - 5.3.1-1
- Update to V5.3.1

* Fri Jun 23 2023 Thomas Serlin <tserlin@redhat.com> - 5.3-1
- Update to V5.3

* Fri Jun 23 2023 Thomas Serlin <tserlin@redhat.com> - 5.2-1
- Update to V5.2

* Fri May 05 2023 Thomas Serlin <tserlin@redhat.com> - 5.1-0.1
- Update to V5.1

* Thu Mar 09 2023 Thomas Serlin <tserlin@redhat.com> - 4.4-0.2
- Build with Prometheus monitoring

* Mon Feb 27 2023 Thomas Serlin <tserlin@redhat.com> - 4.4-0.1
- Update to V4.4

* Tue Sep 27 2022 Ken Dreyer <kdreyer@redhat.com> - 4.0.8-2
- rebuilt for s390x (rhbz#2108325)

* Thu Aug 18 2022 Thomas Serlin <tserlin@redhat.com> - 4.0.8-1
- Update to V4.0.8

* Thu Aug 18 2022 Thomas Serlin <tserlin@redhat.com> - 4.0.7-1
- Update to V4.0.7

* Thu Aug 18 2022 Thomas Serlin <tserlin@redhat.com> - 4.0.6-1
- Update to V4.0.6

* Thu Aug 18 2022 Thomas Serlin <tserlin@redhat.com> - 4.0.5-1
- Update to V4.0.5

* Thu Aug 18 2022 Thomas Serlin <tserlin@redhat.com> - 4.0.4-1
- Update to V4.0.4

* Thu Aug 18 2022 Thomas Serlin <tserlin@redhat.com> - 4.0.3-1
- Update to V4.0.3

* Thu Aug 18 2022 Thomas Serlin <tserlin@redhat.com> - 4.0.2-1
- Update to V4.0.2

* Thu Aug 18 2022 Thomas Serlin <tserlin@redhat.com> - 4.0.1-1
- Update to V4.0.1

* Tue Aug 16 2022 Thomas Serlin <tserlin@redhat.com> 4.0-1
- Update to V4.0

* Tue Jun 14 2022 Ceph Jenkins <ceph-jenkins@redhat.com> 3.5-3
- ganesha-rados-grace: use int type for getopt retval (rhbz#2096882)

* Tue Jun 14 2022 Thomas Serlin <tserlin@redhat.com> - 3.5-2
- nfs-ganesha.spec: Remove unnecessary downstream patches

* Mon Mar 08 2021 Thomas Serlin <tserlin@redhat.com> - 3.5-1
- Update to 3.5

* Sun Dec 13 2020 Thomas Serlin <tserlin@redhat.com> 3.3-3
- FSAL_CEPH: fix create handle return EINVAL (rhbz#1903995)

* Sun Dec 13 2020 Thomas Serlin <tserlin@redhat.com> 3.3-2
- FSAL_CEPH: remove handle argument from ceph_close_my_fd (rhbz#1851102)
- FSAL_CEPH: drop export pointer from ceph_handle (rhbz#1851102)
- FSAL_CEPH: endian-convert wire handles (rhbz#1851102)
- FSAL_CEPH: break up vinodeno_t in wire handle portion (rhbz#1851102)
- FSAL_CEPH: track export id as part of the host handle (rhbz#1851102)
- NFS: add an on-stack buffer for wire_to_host conversions (rhbz#1851102)
- FSAL_CEPH: call fsal_attach_export last (rhbz#1851102)
- FSAL_RGW: allow readdir() to continue past damaged objects (rhbz#1904958)
- selinux: non-fatal yum install error, conditional on ceph-selinux

* Fri Jun 12 2020 Thomas Serlin <tserlin@redhat.com> - 3.3-1
- Update to 3.3

* Fri May 01 2020 Thomas Serlin <tserlin@redhat.com> - 3.2-1
- Update to 3.2

* Thu Apr 30 2020 Thomas Serlin <tserlin@redhat.com> - 2.8.3-6
- spec: bump release, and re-spin for RHEL 8.2

* Thu Apr 16 2020 Thomas Serlin <tserlin@redhat.com> 2.8.3-5
- selinux: move external types to a require{} block
- selinux: additional targeted policy for gluster
- selinux: targeted policy additions for ceph/rgw
- selinux: new policy to allow gluster (glusterd) to start ganesha
- Set no_cleanup=true prior to calling fsal_open2()/fsal_reopen2()
- MDCACHE - Unref chunk when not populating
- There will readdir loop if new_dir_entry in pre_chunk
- Fix all dirents to be skipped if reload_chunk keep work
- MDCACHE - Set next_ck on prev chunk
- Fix lru_reap_chunk_impl racing with mdcache_lru_unref()
- Fix seg fault when NFSv4 compound op fails for regular files.
- Fix accessing object handle after freeing its last state
- Fix get_state_obj_export_owner_refs() fail case

* Thu Mar 26 2020 Ceph Jenkins <ceph-jenkins@redhat.com> 2.8.3-4
- selinux: add local policy for FSAL_VFS and FSAL_RGW (rhbz#1796160 rhbz#1788541 rhbz#1788563)

* Tue Mar 24 2020 Thomas Serlin <tserlin@redhat.com> - 2.8.3-3
- rebuild for ceph-14.2.8 rebase

* Wed Feb 05 2020 Ceph Jenkins <ceph-jenkins@redhat.com> 2.8.3-2
- FSAL_RGW: support fast S3 attrs (v1.1.7) (rhbz#1797817)

* Fri Jan 17 2020 Thomas Serlin <tserlin@redhat.com> 2.8.3-1
- Update to 2.8.3 (rhbz#1791651)

* Thu Jan 16 2020 Thomas Serlin <tserlin@redhat.com> 2.8.2-3
- FSAL_RGW - Track openflags per state (rhbz#1791651)
- FSAL_RGW: restore unconditional close of opened files (rhbz#1791651)

* Fri Nov 08 2019 Thomas Serlin <tserlin@redhat.com> - 2.8.2-2
- nfs-ganesha.spec: fix SELinux

* Mon Oct 28 2019 Thomas Serlin <tserlin@redhat.com> - 2.8.2-1
- Update to 2.8.2

* Mon Oct 07 2019 Yaakov Selkowitz <yselkowi@redhat.com> - 2.8-dev.22.2
- rebuilt

* Tue Jun 18 2019 Thomas Serlin <tserlin@redhat.com> - 2.8-dev.22.1
- rebuilt

* Wed Mar 20 2019 Ken Dreyer <kdreyer@redhat.com> - 2.8-dev.22
- initial import
